/*
 * bbftpc/bbftp_cd.c
 * Copyright (C) Dan Schrager
 * Dan.Schrager@weizmann.ac.il
 */ 

#include "bbftp.h"
#include <sys/types.h>

#include <stdio.h>
#include <string.h>
#include <errno.h>

#include "client.h"
#include "structures.h"
#include "client_proto.h"
#include "common.h"

extern  char    *remotedir ;
extern  int     timestamp;
extern  int     transferoption ;
extern  int     verbose ;

extern int errcode;


int f_handler_cd( char **buffer, int *len, int *code ) {
  if( *code != MSG_OK ) 
    return( BB_RET_NONE );
  
  FREE( remotedir );
  remotedir = strdup( *buffer );
  if( NULL == remotedir ) {
    printmessage(stderr,CASE_ERROR,23,timestamp,"Malloc: %s\n", strerror( errno ) );
    return( BB_RET_ERROR );
  }

  if ( verbose) printmessage(stderr,CASE_NORMAL,0,timestamp,"<< OK : Current remote directory is %s\n",remotedir) ;
  return( BB_RET_OK );
}


int bbftp_cd( char *dirpath ) {
    int		len;
    int		holder;

    if ( verbose) printmessage(stderr,CASE_NORMAL,0,timestamp,">> COMMAND : cd %s\n",dirpath) ;
   
    len = strlen( dirpath );
#ifndef WORDS_BIGENDIAN
    holder = htonl( transferoption );
#else
    holder = transferoption;
#endif
    if( writepackage( MSG_CHDIR_V2, sizeof( holder ) + len, &holder, sizeof( holder ), dirpath, len ) < 0 ) {
      printmessage(stderr,CASE_ERROR,64,timestamp,"Error sending %s message\n", MESSAGE_NAMES[MSG_CHDIR_V2]);
      errcode = 64;
      bbftp_close_control() ;
      return BB_RET_CONN_BROKEN ; /* restart connection */
    }

    return( handlepackage( handler_cd ) ); 
}
