/*
 * bbftpc/bbftp_mkdir.c
 * Copyright (C) Dan Schrager
 * Dan.Schrager@weizmann.ac.il
 */ 

#include "bbftp.h"
#include <sys/types.h>

#include <stdio.h>
#include <string.h>

#include "client.h"
#include "structures.h"
#include "client_proto.h"
#include "common.h"

extern  int     timestamp;
extern  int     transferoption;
extern  int     verbose;

extern int errcode;


int f_handler_mkdir( char **buffer, int *len, int *code ) {
  F_HANDLER_DEFAULT
}

int bbftp_mkdir( char *dirpath ) {
    int		len;
    int		holder;

    if ( verbose) printmessage(stderr,CASE_NORMAL,0,timestamp,">> COMMAND : mkdir %s\n",dirpath) ;
   
    len = strlen( dirpath );
#ifndef WORDS_BIGENDIAN
    holder = htonl( transferoption );
#else
    holder = transferoption;
#endif
    if( writepackage( MSG_MKDIR_V2, sizeof( holder ) + len, &holder, sizeof( holder ), dirpath, len ) < 0 ) {
      printmessage(stderr,CASE_ERROR,64,timestamp,"Error sending %s message\n", MESSAGE_NAMES[MSG_MKDIR_V2]);
      errcode = 64;
      bbftp_close_control() ;
      return BB_RET_CONN_BROKEN ; /* restart connection */
    }

    return( handlepackage( handler_mkdir ) ); 
}
