/*
 * bbftpc/bbftp_rmdir.c
 * Copyright (C) Dan Schrager
 * Dan.Schrager@weizmann.ac.il
 */

#include "bbftp.h"
#include <sys/types.h>

#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>

#include "client.h"
#include "structures.h"
#include "client_proto.h"
#include "common.h"


extern  int     timestamp;
extern  int     verbose;
extern	int	transferoption;

extern xbuffer logmessage;
extern int errcode;

int f_handler_rmdir( char **buffer, int *len, int *code ) {
  F_HANDLER_DEFAULT
}

int bbftp_rmdir( char *path ) {
    int	len;
    int holder;

    if ( verbose) printmessage(stderr,CASE_NORMAL,0,timestamp,">> COMMAND : rmdir %s\n", path );

    len = strlen( path );

#ifndef	WORDS_BIGENDIAN
    holder = htonl( transferoption );
#else
    holder = transferoption;
#endif
    
    if( writepackage( MSG_RMDIR, sizeof( holder ) + len, &holder, sizeof( holder ), path, len ) < 0 ) {
      printmessage( stderr, CASE_ERROR, 64, timestamp, "Error sending %s message\n", MESSAGE_NAMES[MSG_RMDIR] );
      errcode = 64;
      bbftp_close_control() ;
      return BB_RET_CONN_BROKEN ; /* restart connection */
    }

    return( handlepackage( handler_rmdir ) ); 
}
