/*
 * bbftpc/bbftp_setremoteumask.c
 * Copyright (C) Dan Schrager
 * Dan.Schrager@weizmann.ac.il
 */ 

#include "bbftp.h"
#include <sys/types.h>

#include <stdio.h>

#include "client.h"
#include "structures.h"
#include "client_proto.h"
#include "common.h"

extern  int     timestamp;
extern  int     verbose;

extern int errcode;


int f_handler_umask( char **buffer, int *len, int *code ) {
  F_HANDLER_DEFAULT
}

int bbftp_setremoteumask( int mask ) {
    int		holder;

    if ( verbose) printmessage(stderr,CASE_NORMAL,0,timestamp,">> COMMAND : setremoteumask %o\n",mask) ;
    
#ifndef WORDS_BIGENDIAN
    holder = htonl( mask );
#else
    holder = mask;
#endif
    if( writepackage( MSG_CHUMASK, sizeof( holder ), &holder, sizeof( holder ) ) < 0 ) {
      printmessage(stderr,CASE_ERROR,64,timestamp,"Error sending %s message\n", MESSAGE_NAMES[MSG_CHUMASK]);
      errcode = 64;
      bbftp_close_control() ;
      return BB_RET_CONN_BROKEN ; /* restart connection */
    }

    return( handlepackage( handler_umask ) ); 
}
