/*
 * bbftpc/sendproto.c
 * Copyright (C) Dan Schrager
 * Dan.Schrager@weizmann.ac.il
 */ 

#include "bbftp.h"
#include <sys/types.h>

#include <stdio.h>
#include <string.h>

#include "client.h"
#include "structures.h"
#include "client_proto.h"

extern	int timestamp;
extern	int debug;
extern	int warning;

extern	int pasvport_max;
extern	int transferoption;

extern	int errcode;

int protocol;

int sendproto() { 
  int	remoteprotomin;
  int	remoteprotomax;
  int   protocolholder;

  if( pasvport_max ) {
	  protocol = 12;
  } else {
	  protocol = 13;
  }

#ifndef WORDS_BIGENDIAN 
  protocolholder = htonl( protocol );
#else
  protocolholder = protocol;
#endif	
  if( writepackage( MSG_PROT, sizeof( protocolholder ), (char *)(&protocolholder), sizeof( protocolholder ) ) < 0 ) {
    printmessage(stderr,CASE_ERROR,64,timestamp,"Error sending %s message\n", MESSAGE_NAMES[MSG_PROT]);
    bbftp_close_control();
    return( BB_RET_CONN_BROKEN );
  }
	
  if( debug ) printmessage( stderr, CASE_NORMAL, 0, timestamp, "Using bbftpPRO protocol version %d\n", protocol );

  return( BB_RET_OK );
}
