/*
 * bbftpd/bbftpd_cd.c
 * Copyright (C) Dan Schrager
 * Dan.Schrager@weizmann.ac.il
 */ 
#include "bbftpd.h"
#include <sys/types.h>

#include <errno.h>
#include <stdio.h>
#include <syslog.h>
#include <sys/stat.h>
#include <unistd.h>

#include <string.h>

#include "common.h"
#include "daemon.h"
#include "structures.h"
#include "daemon_proto.h"


extern int transferoption ;

extern xbuffer logmessage;

xbuffer thecd = { NULL, 0, 0 };


void bbftpd_cd( char *buffer ) {
    struct mess_dir *msg_dir;
    char   *dirname;
    
    int err;

    msg_dir = (struct mess_dir *)(buffer);

#ifndef WORDS_BIGENDIAN
    transferoption = htonl( msg_dir->transferoption );
#else
    transferoption = msg_dir->transferoption;
#endif
    dirname = msg_dir->dirname ;
    
    syslog(BBFTPD_DEBUG,"Changing directory to %s",dirname) ;
    
    /*
    ** We change the directory
    */

    if( CHDIR( dirname ) < 0 ) {
	
        /*
        ** Depending on errno we are going to tell the client to 
        ** retry or not
        */
        err = ERRNO;
        printxb( &logmessage, "Chdir(%s): %s ", dirname, strerror( err) );
	syslog( BBFTPD_ERR, ptrxb( &logmessage ) );

	reply( (ENOMEM == err || EBUSY == err ? MSG_BAD : MSG_BAD_NO_RETRY), ptrxb( &logmessage ) );
	return;
    }

    emptyxb( &thecd );
    for(;;) {	                      
      if( NULL == appendxb( &thecd, NULL, 128 ) ) {
	printxb( &logmessage, "Realloc: %s", strerror( errno ) );
        mal:
	syslog( BBFTPD_ERR, ptrxb( &logmessage ) );
	reply( MSG_BAD, ptrxb( &logmessage ) );
	return;
      }
      
      if( NULL == GETCWD( ptrxb( &thecd ), lenxb( &thecd ) ) ) {
	      
	err = ERRNO;
	if( ERANGE == errno )
	  continue;
        printxb( &logmessage, "Getcwd : %s ", strerror( err ) );

	emptyxb( &thecd );
	goto mal;
      }
      break;
    }
    
    reply( MSG_OK, ptrxb( &thecd ) );
}
