/*
 * bbftpd/bbftpd_list.c
 * Copyright (C) Dan Schrager
 * Dan.Schrager@weizmann.ac.il
 */ 
#include "bbftpd.h"
#include <sys/types.h>

#include <errno.h>
#include <syslog.h>
#include <sys/stat.h>

#include "common.h"
#include "daemon.h"
#include "structures.h"
#include "daemon_proto.h"
#include "status.h"

extern int  transferoption;

extern xbuffer logmessage;


int bbftpd_list( char *buffer ) {
    char    *filelist ;
    int     filelistlen ;
    int     retcode ;
    struct mess_dir *msg_dir;

    msg_dir = (struct mess_dir *)(buffer);
#ifndef WORDS_BIGENDIAN
    transferoption = ntohl( msg_dir->transferoption );
#else
    transferoption = msg_dir->transferoption;
#endif

    retcode = bbftpd_retrlistdir( msg_dir->dirname, &filelist, &filelistlen );

    if( retcode != 0 ) {
      reply( (retcode < 0 ? MSG_BAD_NO_RETRY : MSG_BAD), ptrxb( &logmessage ) );
      return( 0 );
    }
    
    retcode = writepackage( MSG_LIST_REPL_V2, filelistlen, filelist, filelistlen );
    FREE( filelist );

    if( retcode < 0 ) {
        syslog( BBFTPD_ERR, "Error sending %s message", MESSAGE_NAMES[MSG_LIST_REPL_V2] );
	return( -1 );
    }

    return( 0 );
}
