/*
 * bbftpd/bbftpd_mkdir.c
 * Copyright (C) Dan Schrager
 * Dan.Schrager@weizmann.ac.il
 */ 
#include "bbftpd.h"
#include <sys/types.h>

#include <stdio.h>
#include <syslog.h>

#include "common.h"
#include "daemon.h"
#include "structures.h"
#include "daemon_proto.h"

extern int transferoption ;

extern xbuffer logmessage;


void bbftpd_mkdir( char *buffer ) {
    struct  mess_dir *msg_dir ;
    char    *dirname ;
    int     retcode ;

    msg_dir = (struct mess_dir *)(buffer);

#ifndef WORDS_BIGENDIAN
    transferoption = ntohl( msg_dir->transferoption );
#else
    transferoption = msg_dir->transferoption;
#endif
    dirname = msg_dir->dirname ;
    
    retcode = bbftpd_storemkdir( dirname );
    if( retcode != 0 ) {
      reply( (retcode < 0 ? MSG_BAD_NO_RETRY : MSG_BAD), ptrxb( &logmessage ) );
      return;
    }
    printxb( &logmessage, "Directory %s created", dirname );
    reply( MSG_OK, ptrxb( &logmessage ) );
}
