/*
 * bbftpd/bbftpd_rmdir.c
 * Copyright (C) Dan Schrager
 * Dan.Schrager@weizmann.ac.il
 */
#include "bbftpd.h"
#include <sys/types.h>

#include <stdio.h>
#include <syslog.h>
#include <errno.h>
#include <unistd.h>
#include <string.h>

#include "common.h"
#include "daemon.h"
#include "structures.h"
#include "daemon_proto.h"


extern	int	transferoption;

extern xbuffer logmessage;


void bbftpd_rmdir( char *buffer ) {
    char *path;
    int  ret;

    memcpy( (char *)(&transferoption), buffer, sizeof( int ) );
#ifndef	WORDS_BIGENDIAN
    transferoption = ntohl( transferoption );
#endif
    
    path = buffer + sizeof( int );
    
    ret = RMDIR( path );
    
    if( ret != 0 )
      printxb( &logmessage, "Rmdir(%s): %s", path, strerror( ERRNO ) );
    else
      printxb( &logmessage, "Directory %s deleted", path );
   
    reply( (ret != 0 ? MSG_BAD_NO_RETRY : MSG_OK), ptrxb( &logmessage ) );
}
