/*
 * includes/daemon_proto.h
 * Copyright (C) 1999, 2000, 2001, 2002 IN2P3, CNRS
 * bbftp@in2p3.fr
 * http://doc.in2p3.fr/bbftp
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */ 

/****************************************************************************

  
  
 daemon_proto.h v 2.1.0 2001/03/21  - Header creation

*****************************************************************************/

#include <utime.h>

#include <openssl/rsa.h>
#include <openssl/err.h>
#include <openssl/rand.h>
#include <openssl/evp.h>
#include <openssl/pem.h>
#include <openssl/md5.h>
#include "openssl.h"

typedef struct rsalist {
        RSA *rsa;
        struct rsalist *next;
} rsal;

/*
** Prototype for utilities
*/
void checkfromwhere() ;
int checkprotocol() ;
void clean_child() ;
void exit_clean() ;
void strip_trailing_slashes (char *path) ;
void free_all_var() ;
/*
** Prototypes for message routines
*/
int readmessage( char *buffer, int msglen, int to);

void reply( int code, char *str );

int writemessage( char *buffer, int msglen, int to );

unsigned char *readpackage( int *length, int *code, unsigned char *bucket );

int writepackage( int code, int msglen, ... );

/*
** Prototypes for signal routines
*/
int bbftpd_setsignals() ;

int bbftpd_setdaemonsignals() ;
void bbftpd_mysigchld();

/*
** Prototype for sockets
*/

/*
** Prototype for global private authentication routines
*/
int bbftpd_private_receive_connection( char *buffer );
int bbftpd_private_send( char *buffertosend, int buffertosendlength );
int bbftpd_private_recv( char *buffertorecv, int lengthtorecv );
/*
** Prototype for user private authentication routines
*/
int bbftpd_private_auth();
/*
** Prototype for retr routines
*/
int bbftpd_retrcheckfile( char *filename );
int bbftpd_retrlistdir( char *pattern, char **filelist, int *filelistlen );

my64_t filelength( char *filename );

/*
** Prototype for store routines
*/
void bbftpd_storecheckoptions();
int bbftpd_storechmod( char *filename, int mode );
int bbftpd_storecreatefile( char *filename );
int bbftpd_storemkdir( char *dirname );
int bbftpd_storerename( char *oldpath, char *newpath );
int bbftpd_storeunlink( char *filename );
int bbftpd_storeutime( char *filename, struct utimbuf *ftime );

/*
** Prototype for main routines
*/
void bbftpd_cd( char *buffer );
int bbftpd_list( char *buffer );
void bbftpd_mkdir( char *buffer );
void bbftpd_mklnk( char *buffer );
int bbftpd_readcontrol( int msgcode, int msglen );

int start_pumps();

int end_file();

int authsequence( char *buffer );
int bbftpd_setfathersignals();
int get_ip( char *host, char **fhost );
int handlepackage( int handle );
int loginsequence( char *buffer );
void do_daemon(int argc,char **argv,char **envp);
void sendcrypt();
void stir();
RSA *key_new();
void genmyprsa();
int writepackage( int code, int msglen, ... );
BIGNUM *auth_generate_challenge(RSA *key);
int auth_verify_response(RSA *key, BIGNUM *challenge, u_char response[16]);
int decodersapass( struct mess_rsa *msg_rsa, char *username, char *password );
int key_equal(RSA *a, RSA *b);
int key_try_load_public(rsal **k, const char *filename, char **commentp);
int saversa( char *buffer );
int bbftpd_getdatasock(int nbsock);
int bbftpd_makedatasock( int nbsock/*, unsigned short int *localports*/ );
void bbftpd_delete( char *buffer );
void bbftpd_rmdir( char *buffer );
void free_f_var();
int bbftpd_setchildsignals();
int bbftpd_setsonsignals();
int closecastfd();
int readpipe( int p, char *buffer, int len );
int writepipe( int p, char *buffer, int len );
void free_n_var();
void recrypt();
void opendoors();
