#if defined( WITH_RFIO ) || defined( WITH_RFIO64 )
#include <rfio_api.h>
#include <serrno.h>
#endif


#if defined( WITH_RFIO ) || defined( WITH_RFIO64 )
#define	ERRNO	( serrno ? serrno : errno )
#define	sERRNO	serrno = errno
#else
#define	ERRNO	( errno )
#define	sERRNO	errno
#endif


#if (defined( NONSTANDARD_FILE_CALL ) || defined( WITH_RFIO64 )) && !defined( WITH_RFIO )
#define	sSTAT	struct stat64
#define	OFF_T	off64_t
#else
#define	sSTAT	struct stat
#define	OFF_T	off_t
#endif


#if defined( WITH_RFIO64 ) && defined( NONSTANDARD_FILE_CALL )
#define fSTAT   struct stat64
#else
#define fSTAT   struct stat
#endif


#if !defined( WITH_RFIO ) && !defined( WITH_RFIO64 )
#if defined( NONSTANDARD_FILE_CALL ) && defined( NONSTANDARD_READDIR_CALL )
#define READDIR readdir64
#else
#define READDIR readdir
#endif
#endif


#if defined( NONSTANDARD_FILE_CALL ) && !defined( WITH_RFIO ) && !defined( WITH_RFIO64 ) && defined( NONSTANDARD_READDIR_CALL )
#define	sDIRENT	struct dirent64
#else
#define	sDIRENT	struct dirent
#endif

#undef	FWRITE
#undef	FREAD
#undef	FOPEN
#if defined( WITH_RFIO ) || defined( WITH_RFIO64 )
#define OPENDIR		rfio_opendir
#define CLOSEDIR	rfio_closedir
#define CHDIR		rfio_chdir
#define GETCWD		rfio_getcwd
#define READ		rfio_read
#define	FREAD		rfio_fread
#define WRITE		rfio_write
#define	FWRITE		rfio_fwrite
#define CLOSE		rfio_close
#define FCLOSE		rfio_fclose
#define MKDIR		rfio_mkdir
#define	RMDIR		rfio_rmdir
#define CHMOD		rfio_chmod
#define	CHOWN		rfio_chown
#define RENAME		rfio_rename
#define UNLINK		rfio_unlink
#define	READLINK	rfio_readlink
#define	SYMLINK		rfio_symlink
#define	FERROR		rfio_ferror
#define	FEOF		rfio_feof
#define	FILENO		rfio_fileno
#define	ACCESS		rfio_access
#ifdef WITH_RFIO
#define STAT		rfio_stat
#define LSTAT		rfio_lstat
#define	FSTAT		rfio_fstat
#define OPEN		rfio_open
#define FOPEN		rfio_fopen
#define LSEEK		rfio_lseek
#define	READDIR		rfio_readdir
#else
#define STAT		rfio_stat64
#define LSTAT		rfio_lstat64
#define	FSTAT		rfio_fstat64
#define OPEN		rfio_open64
#define FOPEN		rfio_fopen64
#define LSEEK		rfio_lseek64
#define	READDIR		rfio_readdir64
#endif
#else
#define OPENDIR		opendir
#define CLOSEDIR	closedir
#define CHDIR		chdir
#define GETCWD		getcwd
#define READ		read
#define	FREAD		fread
#define WRITE		write
#define	FWRITE		fwrite
#define CLOSE		close
#define	FCLOSE		fclose
#define MKDIR		mkdir
#define	RMDIR		rmdir
#define CHMOD		chmod
#define	CHOWN		chown
#define RENAME		rename
#define UNLINK		unlink
#define	READLINK	readlink
#define	SYMLINK		symlink
#define FOPEN		fopen
#define	FSTAT		fstat
#define	FERROR		ferror
#define	FEOF		feof
#define	FILENO		fileno
#define	ACCESS		access
#ifdef	NONSTANDARD_FILE_CALL
#define	STAT		stat64
#define	LSTAT		lstat64
#define	OPEN		open64
#define	LSEEK		lseek64
#else
#define STAT		stat
#define LSTAT		lstat
#define OPEN		open
#define LSEEK		lseek
#endif
#endif
